(deffunction sort_disks (?a ?b)
  (return (> (fact-slot-value ?a disk) (fact-slot-value ?b disk)))
)

(deffunction disk_to_string (?disk)
  (switch ?disk
    (case -1 then (return "       "))
    (case 0 then (return "   |   "))
    (case 1 then (return "  -|-  "))
    (case 2 then (return " --|-- "))
    (case 3 then (return "---|---"))
    (case 4 then (return "   A   "))
    (default (return " err  "))
  )
)

(deffunction append$ (?list $?items)
  (return (insert$ ?list (+ (length$ ?list) 1) ?items))
)

(deffunction prepend$ (?list $?items)
  (return (insert$ ?list 1 ?items))
)

(deffunction get_peg_content (?peg)
  (bind ?curr-disks (find-all-facts ((?on-a on)) (eq ?on-a:peg ?peg)))
  (bind ?curr-disks (sort sort_disks ?curr-disks))
  (bind ?peg_content (create$))
  (progn$ (?d ?curr-disks)
     (bind ?peg_content (append$ ?peg_content (fact-slot-value ?d disk)))
  )
  (while (< (length$ ?peg_content) 3) do
    (bind ?peg_content (prepend$ ?peg_content 0))
  )
  (return (prepend$ (append$ ?peg_content 4) -1))
)

(deffunction print_all ()
  (bind ?peg-a (get_peg_content A))
  (bind ?peg-b (get_peg_content B))
  (bind ?peg-c (get_peg_content C))
  (progn$ (?i ?peg-a)
    (printout t (disk_to_string (nth$ ?i-index ?peg-a)) " "
                (disk_to_string (nth$ ?i-index ?peg-b)) " "
                (disk_to_string (nth$ ?i-index ?peg-c)) crlf)
  )
)

(defrule print-table
  ?p <- (print)
=>
  (print_all)
  (retract ?p)
)
